/* daemonProgram.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef DAEMONPROGRAM_H
#define DAEMONPROGRAM_H

// This is a base class for any Paloma utility program that normally
// forks itself as a daemon and runs in the background.

#include "databaseProgram.h"

class DaemonProgram : public DatabaseProgram {
public:
  DaemonProgram(const string &program_name);

  virtual void run();

  // This is the main function to override to define the main
  // operation of the daemon.  This function will be run in a forked
  // child process (unless the user specifies -f).
  virtual void run_daemon()=0;

protected:
  virtual void handle_opts(const string &opt, const string &arg);

  virtual void describe_options();

  bool _nofork;
};

#endif
