/* referenceCount.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef REFERENCECOUNT_H
#define REFERENCECOUNT_H

#include <stdlib.h>  // For NULL definition.

class ReferenceCount {
protected:
  ReferenceCount();
  ReferenceCount(const ReferenceCount &copy);
  ReferenceCount &operator = (const ReferenceCount &copy);

  virtual ~ReferenceCount();

private:

#ifndef NDEBUG
  // We'll store this flag just to make sure the ReferenceCount object
  // didn't accidentally get deleted when we weren't looking.
  int _alive_test;
#endif

  int _ref_count;
  friend class ReferenceCountProxy;
};

class ReferenceCountProxy {
public:
  ReferenceCountProxy(ReferenceCount *ptr = (ReferenceCount *)NULL);
  ReferenceCountProxy(const ReferenceCountProxy &copy);
  ReferenceCountProxy &operator = (const ReferenceCountProxy &copy);
  ~ReferenceCountProxy();

  bool operator == (const ReferenceCountProxy &other) const;

  void clear();

protected:
  void set_ptr(ReferenceCount *ptr);
  ReferenceCount *get_ptr() const;

private:
  ReferenceCount *_ptr;
};


#endif

